#include<stdio.h>
#include<string>
#include<time.h>
#include<stdlib.h>
#include<algorithm>
#include<iostream>

#define MAXL 2000000000
#define MAXS 1000
#define MAX 20000

using namespace std;

int a[22222];
int b[22222];

void generate_simple(const char* output)
{
	int S = 1 + rand() % 5;
	int L = 10 + rand() % 10;
	int A = 1 + rand() % 4;
	int B = 1 + rand() % 4;
	for (int i = 0; i < A; i++) {
		a[i] = rand() % L;
	}
	for (int i = 0; i < B; i++) {
		b[i] = rand() % L;
	}
	sort(a, a + A);
	sort(b, b + B);
	A = unique(a, a+A) - a;
	B = unique(b, b+B) - b;

	FILE *f = fopen(output, "w");
	fprintf(f, "%d %d %d %d\n", L, S, A, B);
	for (int i = 0; i < A; i++)
		fprintf(f, "%d\n", a[i]);
	for (int i = 0; i < B; i++)
		fprintf(f, "%d\n", b[i]);
	fclose(f);
}

void generate_middle(const char* output)
{
	int S = 1 + rand() % 1000;
	int L = 10 + rand() % 1999999990;
	int A = 500 + (rand() % L) % 500;
	int B = 500 + (rand() % L) % 500;
	for (int i = 0; i < A; i++) {
		a[i] = rand() % L;
	}
	for (int i = 0; i < B; i++) {
		b[i] = rand() % L;
	}
	sort(a, a + A);
	sort(b, b + B);
	A = unique(a, a+A) - a;
	B = unique(b, b+B) - b;

	FILE *f = fopen(output, "w");
	fprintf(f, "%d %d %d %d\n", L, S, A, B);
	for (int i = 0; i < A; i++)
		fprintf(f, "%d\n", a[i]);
	for (int i = 0; i < B; i++)
		fprintf(f, "%d\n", b[i]);
	fclose(f);
}

void generate_hard(const char* output)
{
	int L = MAXL, S = MAXS;
	for (int i = 0; i < MAX; i++) {
		a[i] = rand() % MAXL;
		b[i] = rand() % MAXL;
	}
	sort(a, a+MAX);
	sort(b, b+MAX);
	int A = unique(a, a+MAX) - a;
	int B = unique(b, b+MAX) - b;

	FILE *f = fopen(output, "w");
	fprintf(f, "%d %d %d %d\n", L, S, A, B);
	for (int i = 0; i < A; i++)
		fprintf(f, "%d\n", a[i]);
	for (int i = 0; i < B; i++)
		fprintf(f, "%d\n", b[i]);
	fclose(f);
}


int main()
{
	srand(0);
	
	generate_simple("p3-5data/in.01");
	generate_simple("p3-5data/in.02");
	generate_simple("p3-5data/in.03");
	
	generate_middle("p3-5data/in.04");
	generate_middle("p3-5data/in.05");
	generate_middle("p3-5data/in.06");
	generate_middle("p3-5data/in.07");
	generate_middle("p3-5data/in.08");
	generate_middle("p3-5data/in.09");
	generate_middle("p3-5data/in.10");

	generate_hard("p3-5data/in.11");
	generate_hard("p3-5data/in.12");
	generate_hard("p3-5data/in.13");
	generate_hard("p3-5data/in.14");
	generate_hard("p3-5data/in.15");
	
	return 0;
}
