#include<stdio.h>
#include<math.h>
#define MAX 20100

double L;   // dlka kanlu
double S;   // ka kanlu
int A,B;    // poet vybranch mst na lev a prav stran kanlu
double a[MAX],b[MAX];
            // umstn vybranch mst na lev a prav stran kanlu
char optimalni_reseni[MAX][MAX/4];
            // bitov pole pro uloen optimlnho een
	    // nsleduj makra pro prci s tmto polem
#define prirad(pole,pozice,hodnota) pole[(pozice)/4]|=(hodnota)<<(2*((pozice)%4))
#define vrat(pole,pozice) ((pole[(pozice)/4]>>(2*((pozice)%4)))&3)

double spocitej_delku(double x, double y) {
  // vypote dlku pvozu mezi msty ve vzdlenostech x a y na stranch kanlu	 
  return sqrt((x-y)*(x-y)+S*S);
  }  

void nacti_zadani(void) {
  int i,j;  // pomocn promnn pro for-cykly
  scanf("%lf %lf %d %d",&L,&S,&A,&B);
  for (i=0; i<A; i++) scanf("%lf",&a[i]);
  for (j=0; j<B; j++) scanf("%lf",&b[j]);
  }	

double najdi_reseni(void) {
  double soucet_delek[MAX];
            // pomocn pole pro dynamick programovn
	    // j-t hodnota obsahuje souet dlek v optimlnm een pro i a j
  double stara_predchozi_hodnota;
            // pomocn promnn pro dynamick programovn
	    // hodnota pro i-1 a j-1 - tmto se vyhneme manipulaci s dvma poli
  double varianta1,varianta2,varianta3;
            // pomocn promnn pro porovnn t variant napojen
	    // sla variant odpovdaj jejich bitovm maskm
  int i,j;  // pomocn promnn pro for-cykly
  // inicializace pol soucet_delek a optimalni_reseni[0][*]
  soucet_delek[0]=spocitej_delku(a[0],b[0]);
  prirad(optimalni_reseni[0],0,3);
  for (j=1; j<B; j++) {
    prirad(optimalni_reseni[0],j,2);
    soucet_delek[j]=soucet_delek[j-1]+spocitej_delku(a[0],b[j]);
    }
  // vpoet hodnot pol soucet_delek a optimalni_reseni
  for (i=1; i<A; i++) {
    stara_predchozi_hodnota=soucet_delek[0];
    soucet_delek[0]=soucet_delek[0]+spocitej_delku(a[i],b[0]);
    prirad(optimalni_reseni[i],0,1);
    for (j=1; j<B; j++) {
      varianta1=soucet_delek[j];         // msta i-1 a j jsou spojena pvozem
      varianta2=soucet_delek[j-1];       // msta i a j-1 jsou spojena pvozem
      varianta3=stara_predchozi_hodnota; // msta i-1 a j-1 jsou spojena pvozem
      stara_predchozi_hodnota=soucet_delek[j];
      // porovnn tr monch variant een
      if ((varianta1<varianta2)&&(varianta1<varianta3)) {
        soucet_delek[j]=varianta1+spocitej_delku(a[i],b[j]);;
	prirad(optimalni_reseni[i],j,1);
	continue;
	}
      if (varianta2<varianta3) {
        soucet_delek[j]=varianta2+spocitej_delku(a[i],b[j]);
	prirad(optimalni_reseni[i],j,2);
	continue;
	}
      soucet_delek[j]=varianta3+spocitej_delku(a[i],b[j]);
      prirad(optimalni_reseni[i],j,3);
      }
    }

    return soucet_delek[B - 1];
  }

int main(int argc, char *argv[]) {
  double r;

  nacti_zadani();
  r = najdi_reseni();
  printf ("%lf\n", r);
  return 0;
  }
